<?php

final class Db 
{
	private static $Instance;	
	
	public static function Singleton() {
		if (!isset(self::$Instance)) {
			switch (CONF_DB_DRIVER) {
				case 'mysqli':
					$ClassName = 'DbAccess';
					break;
				case 'mysql':
					$ClassName = 'DbAccessComp';
					break;
				default:
					trigger_error('Incorrect database driver', E_USER_ERROR);
					exit;
			}
			self::$Instance = call_user_func(array($ClassName, 'Singleton'));
		}
		return self::$Instance;
	}
	private function __construct() {}
	private function __clone() {}
}

?>