<?php

class ProxyGrabber extends Requester 
{
	private static $GrabPatterns;
	private $Proxies;
	private $db;

	private $id;
	private $Url;
	private $Hash;
		

	
	
	public function __construct($id, $url) {
		parent::__construct();		
		$this->db = Db::Singleton();
		$this->id = $id;
		$this->Url = $url;
		$this->PrepareRequest();
	}
	
	public function GetId() {
		return $this->id;
	}

	public function GetUrl() {
		return $this->Url;
	}

	public function GetCount() {
		return count($this->Proxies);
	}

	public function GetProxies() {
		return $this->Proxies;
	}
	
	
	
	
	public function Parse() {
		if ($this->IsOk()) {
			$this->Proxies = self::GrabProxy($this->GetResult());
			$this->Hash = md5($this->GetResult());
		}
	}
	
	/**
	* Grabs proxy from any text
	* @param string $Text
	* @return array
	*/
	public static function GrabProxy($Text) {
		require_once('configs/GrabPatterns.php');
		$Text = self::HtmlAsciiDecode($Text);
		$Text = html_entity_decode($Text);		
		$Proxies = array();
		foreach (self::$GrabPatterns as $Pattern) {
			if (preg_match_all($Pattern, $Text, $m, PREG_SET_ORDER)) {
				foreach ($m as $v) {
					list($host, $port) = self::MakeProxy($v);
					$ip = self::Str2ip($host);
					if ($ip==false) continue;
					$Proxies[] = $ip.':'.$port;
				}
			}
		}
		return $Proxies;		
	}
	
	public static function HtmlAsciiDecode($Text) {
		return preg_replace_callback(
			"/&#(\d+)/",
			create_function('$m', 'return chr($m[1]);' ),
			$Text
		);
	}
	
	
	
	
	public function Save() {
		if ($this->IsError()) {
			$this->db->Query("UPDATE urls SET"
				. " date_grab = NOW(),"				
				. " errors = errors+1,"
				. " count_proxy = 0,"
				. " code_curl = ".intval($this->GetErrno()).","
				. " code_http = ".intval($this->GetHttpCode())
				. " WHERE id=".intval($this->id)
				);
			return;
		}

		self::AddProxyToDb($this->Proxies, $this->id);
			
		$this->db->Query("UPDATE urls SET"
			. " date_grab = NOW(),"
			. " date_update = IF(hash<>'".addslashes($this->Hash)."', NOW(), date_update),"
			. " errors = 0,"
			. " count_proxy = ".intval($this->GetCount()).","
			. " code_curl = ".intval($this->GetErrno()).","
			. " code_http = ".intval($this->GetHttpCode()).","
			. " hash = '".addslashes($this->Hash)."'"
			. " WHERE id=".intval($this->id)
			);
	}
	
	public static function AddProxyToDb($Proxies, $UrlId=0) {
		if (!empty($Proxies)) {
			$Portions = array_chunk($Proxies, 200);
			foreach ($Portions as $v) {
				$v = array_map('addslashes', $v);
				$UrlId = intval($UrlId);
				Db::Singleton()->Query("INSERT IGNORE INTO proxy (proxy, url_id, date_add)"
					. " VALUES ('".implode("', ".$UrlId.", NOW()),\r\n('",$v)."', ".$UrlId.", NOW())" );
			}
		}
	}
	
	
	
	
	private function PrepareRequest() {
		$this->SetUrl($this->Url);
		$this->SetOpt(CURLOPT_REFERER, $this->Url);
		$this->SetOpt(CURLOPT_CONNECTTIMEOUT, DbConfig::Singleton()->GetParam('grab_connect_timeout'));
		$this->SetOpt(CURLOPT_TIMEOUT, DbConfig::Singleton()->GetParam('grab_request_timeout'));
		$this->SetOpt(CURLOPT_FAILONERROR, true);
	}
	
	private static function Str2ip($Host) {
		$IsIp = '#^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$#';
		if (DbConfig::Singleton()->GetParam('grab_str2ip')) {
			if (preg_match($IsIp, $Host)) return $Host;
			$ip = gethostbyname($Host);
			if (!preg_match($IsIp, $ip)) return false;
			return $ip;
		}
		return $Host;
	}
	
	private static function MakeProxy($Matches) {
		unset($Matches[0]);
		if (count($Matches)==2) return array($Matches[1], $Matches[2]);
		if (count($Matches)==5) return array($Matches[1].'.'.$Matches[2].'.'.$Matches[3].'.'.$Matches[4], $Matches[5]);
		return $Matches;
	}
}

?>