<?php
define('DEBUG_STORE_FILE', 'logs/debug.txt');
define('DEBUG_STORE_FILE_APPEND', true);



class DebugStore
{
	private $StoreFile;
	private $Append;
	
	
	/**
	* @param mixed $value - value to store
	* @param string[optional] $file - store file
	* @param bool[optional] $append - append or recreate store file
	*/	
	function __construct($value, $file=DEBUG_STORE_FILE, $append=DEBUG_STORE_FILE_APPEND) {
		$this->SetStoreFile($file);
		$this->SetAppend($append);
		$this->Add($value, $append);
	}
	
	/**
	* SET FILE FOR STORE DEBUG VALUES
	* @param string $file
	*/
	public function SetStoreFile($file) {
		$this->StoreFile = $file;
	}

	/**
	* SET STORE FILE APPEND MODE
	* @param bool $append
	*/
	public function SetAppend($append) {
		$this->Append = $append ? DEBUG_STORE_FILE_APPEND : 0;
	}
	
	/**
	* PUT NEW DEBUG VALUE
	* @param mixed $value
	* @param bool[optional] $append - append or recreate store file
	*/
	public function Add($value) {
		$content = "\n===============================================[".date("Y-m-d H-i-s")."]\n";
		$content .= $this->var_dump_return($value);
		file_put_contents($this->StoreFile, $content, $this->Append);
	}
	
	/**
	* PUT INFO STRING
	* @param string $text
	*/
	public function AddInfo($info) {
		$content = "\n-----------------------------------------------\n";
		$content .= $info;
		$content .= "\n-----------------------------------------------\n";
		file_put_contents($this->StoreFile, $content, $this->Append);
	}
	
	/**
	* RETURNS THE VALUE OF VAR_DUMP INSTEAD OF OUTPUTTING IT
	*/
	private function var_dump_return($value) {
		ob_start();
		var_dump($value);
		$content = ob_get_contents();
		ob_end_clean();
		return $content;
	}	
}

?>