<?php

class ErrorHandler 
{
	private $Display = false;
	private $Logging = false;
	private $LogFile = false;
	

	
	
	public function __construct() {
		$this->ActivateHandler();
	}
	
	public function __destruct() {
		$this->RestoreHandler();
	}
	

	

	
	public function DisplayOn() {
		$this->Display = true;
	}
	
	public function DisplayOff() {
		$this->Display = false;
	}
	
	public function SetLogFile($File) {
		$this->LogFile = $File;
	}

	public function LoggingOn() {
		$this->Logging = true;
	}
	
	public function LoggingOff() {
		$this->Logging = false;
	}

	public function ActivateHandler() {
		set_error_handler(array($this, 'Handler'));
	}

	public function RestoreHandler() {
		restore_error_handler();
	}
	
	
	
	
	
	public function Handler($errno, $errstr, $errfile, $errline) {
		$ErrorReporting = error_reporting();
		if ($errno & $ErrorReporting) {
			$errortype = array (
				E_ERROR              => 'Error',
				E_WARNING            => 'Warning',
				E_PARSE              => 'Parsing error',
				E_NOTICE             => 'Notice',
				E_CORE_ERROR         => 'Core error',
				E_CORE_WARNING       => 'Core warning',
				E_COMPILE_ERROR      => 'Compile error',
				E_COMPILE_WARNING    => 'Compile warning',
				E_USER_ERROR         => 'User error',
				E_USER_WARNING       => 'User warning',
				E_USER_NOTICE        => 'User notice',
				E_STRICT             => 'Strict error'
				);		
			$type = isset($errortype[$errno]) ? $errortype[$errno] : 'Unknown error type';
			$this->Send(sprintf("[%s] %s on line %d in %s", $type, $errstr, $errline, $errfile));
		}
	}
	
	private function Send($Message) {
		if($this->Display) $this->Display($Message);
		if($this->Logging) $this->AddLog($Message);
	}
	
	private function Display($Message) {
		print "<br>\r\n".$Message . "<br>\r\n";
	}
	
	private function AddLog($Message) {
		// format message
		$Message = sprintf("[%s] %s\r\n", date("Y-m-d H:i:s"), $Message);
		
		// write to file
		$fp=fopen($this->LogFile, 'ab');
		if(!$fp) die("ErrorHandler: Cannot open log file: ".$this->LogFile);
		if(fwrite($fp, $Message)===false) die("ErrorHandler: Cannot write to log file: ".$this->LogFile);
		fclose($fp);
		
		chmod($this->LogFile, 0777);
	}	
}

?>