<?php

final class ProcessController
{
	private static $Instance;
	private $db;
	private $Pid;
	private $Pnum;
	private $Started;
	private $Updated;
	private $Time;
	private $Action;
	private $ActionsCount;
	private $LogFile;

	
	
	public static function Singleton() {
		if (!isset(self::$Instance)) {
			$ClassName = __CLASS__;
			self::$Instance = new $ClassName();
		}
		return self::$Instance;
	}
	private function __clone() {}
	private function __construct() {
		$this->db = Db::Singleton();
		$this->TerminateZombieProcesses();
		$this->StartProcess();
	}
	public function __destruct() {
		@$this->TerminateProcess();
	}
	
	
	
	


	
	public function SetLogFile($FileName) {
		$this->LogFile = $FileName;
		$this->db->Query("UPDATE processes SET log_file='".addslashes($this->LogFile)."' WHERE pid=".intval($this->Pid));
	}
	
	public function AddAction($Text) {
		$this->Updated = time();
		$this->Time = $this->Updated - $this->Started;
		$this->Action = $Text;
		$this->ActionsCount++;
		$this->db->Query("UPDATE processes SET "
			." updated=FROM_UNIXTIME(".intval($this->Updated)."),"
			." time='".addslashes($this->Time)."',"
			." action='".addslashes($this->Action)."',"
			." actions_count=".intval($this->ActionsCount)
			." WHERE pid=".intval($this->Pid));
		$this->CheckKill();
	}
	
	
	
	
	public function GetPid() {
		return $this->Pid;
	}
	
	public function GetPnum() {
		return $this->Pnum;
	}
	
	public function GetStarted() {
		return $this->Started;
	}
	
	public function GetUpdated() {
		return $this->Updated;
	}
	
	public function GetTime() {
		return $this->Time;
	}
	
	public function GetAction() {
		return $this->Action;
	}
	
	public function GetActionsCount() {
		return $this->ActionsCount;
	}
	
	public function GetLogFile() {
		return $this->LogFile;
	}
	
	public function GetInfo() {
		return array(
			'pid' =>			$this->Pid,
			'started' =>		$this->Started,
			'updated' =>		$this->Updated,
			'time' =>			$this->Time,
			'action' =>			$this->Action,
			'actions_count' =>	$this->ActionsCount,
			'log_file' =>		$this->LogFile,
			);
	}
	
	
	
	
	
	
	
	private function StartProcess() {
		$this->db->Begin();
		$this->Pid = getmypid();
		$this->Pnum = $this->GeneratePnum();
		$this->Started = time();
		$this->Updated = $this->Started;
		$this->Time = 0;
		$this->Action = '';
		$this->ActionsCount = 0;
		$this->LogFile = '';
		$this->db->Query("INSERT IGNORE INTO processes SET "
			." pid=".intval($this->Pid).","
			." pnum=".intval($this->Pnum).","
			." started=FROM_UNIXTIME(".intval($this->Started)."),"
			." updated=FROM_UNIXTIME(".intval($this->Updated)."),"
			." time='".addslashes($this->Time)."',"
			." action='".addslashes($this->Action)."',"
			." actions_count=".intval($this->ActionsCount)).","
			." log_file='".addslashes($this->LogFile)."'";
		$this->db->Commit();
	}
	
	private function GeneratePnum() {
		$this->db->Query('SELECT pnum FROM processes FOR UPDATE');
		$Pnums = $this->db->FetchColumn();
		for ($i=1; true; $i++) {
			if (!in_array($i, $Pnums)) break;
		}
		return $i;
	}
	
	private function CheckKill() {
		$this->db->Query('SELECT 1 FROM processes WHERE pid='.intval($this->Pid).' AND `kill`=1');
		if ($this->db->FetchCell()) exit;
	}
	
	private function TerminateProcess() {
		$this->db->Query('DELETE FROM processes WHERE pid='.intval($this->Pid));
	}
	
	private function TerminateZombieProcesses() {
		$this->db->Query('DELETE FROM processes WHERE UNIX_TIMESTAMP()-UNIX_TIMESTAMP(updated) > '.intval(CONF_ZOMBIE_PROC_TIME));
	}
	
}

?>